package MaxSpanPack;

import java.util.Arrays;

public class MaxSpan {

	//Solution 1
	/*public static int maxSpan(int[] array) {
		   int max = 0;
		   for (int i = 0; i < array.length; i++) {
		      int j = array.length - 1;
		      for ( ; j >= i; j--) {
		         if (array[i] == array[j]) {
		            break;
		         }
		      }
		      int span = j - i + 1;
		      if (max < span) {
		         max = span;
		      }
		   }
		   return max;

	}*/
	
	//Solution 2
	public static int maxSpan(int[] nums) {
		int max = 0;
		for (int value: values(nums)) {
			max = Math.max(max, span(value, nums));
		}
		return max;
	}

	private static int span(int value, int[] nums) {
		return lastIndexOf(value, nums) - firstIndexOf(value, nums) + 1;
	}

	
	private static int[] values(int[] nums) {
		int[] values = new int[nums.length];
		int nextIndex = 0;

		for (int i = 0; i < nums.length; i++) {
			if (!contains(values, nextIndex, nums[i])) {
				add(values, nextIndex++, nums[i]);
			}
		}

		return Arrays.copyOf(values, nextIndex);
	}
	private static int lastIndexOf(int value, int[] nums) {
		for (int i = nums.length - 1; i >=0; i--) {
			if (nums[i] == value) {
				return i;
			}
		}
		// should never get here
		return -1;
	}
	private static int firstIndexOf(int value, int[] nums) {
		int index = -1;
		for (int i = 0; i < nums.length; i++) {
			if (nums[i] == value) {
				index = i;
				break;
			}
		}
		return index;
	}
	private static void add(int[] values, int position, int value) {
		values[position] = value;
	}

	private static boolean contains(int[] temp, int tempLength, int value) {
		for (int i = 0; i < tempLength; i++) {
			if (temp[i] == value) {
				return true;
			}
		}
		return false;
	}


}
